Subject: Re: [rohc] ROHC context reuse & mode

From: Kristofer Sandlund <[email-masked]>
Date: Tue, 06 Apr 2004 17:03:16 +0200

Hi Pawel.

Comments inlined.

Pawel Szymanski wrote:
> Hi Kristofer,
> 
> I found in the mailing list archive an interesting discussion about context 
> reuse (see http://www1.ietf.org/mail-archive/working-
> groups/rohc/current/msg02000.html).
> 
> I am particulary interested in the procedure of handling IR packets wihtout 
> dynamic header chain. You gave the following rules of processing such packets:
> 
> "* IR-no-dynchain packets (see 5.7.7 and 5.7.7.2 in RFC3095)
> These packets (which will be transmitted without payload), only update the 
> static part of the context and are then to be discarded, and not passed on to 
> upper layers. Since we allow context to be kept by the decompressor when IR 
> packets are received, we feel that this should not have to invalidate the 
> dynamic chain, and we propose adding one sentence (impl. guide again) to 
> describe that these packets only update the static chain."
> 
> Do you know in what circumstances compressor may decide to send IR packet 
> without the dynamic chain ?
> 

Some examples of _possible_ ways to use this (the 3095-authors might have more 
realistic examples to give):

One possible usage is to actually construct IR-no-dyn-no-payload packets even 
when no data is received (either as a "keep-alive" or as initialization if the 
flow's static info is somehow known a priori).
Another possible use is to discard the data of the first few packets and only 
send the static chain to initialize the context (to save bandwidth/delay at 
initialization).

The most likely use case for this should be links with a limited maximum packet 
size.

> What should be the state of the context in decompressor after successful 
> processing of such a packet ? I can see three possible alternatives:
> 
> 1. The state is left unchanged - but when the decompressor was in NO_CONTEXT 
> state. Since the decompressor know knowns the static chain it should rather 
> advance the state to the STATIC_CONTEXT state.
> 
> 2. The state is set to STATIC_CONTEXT - but when the decompressor was in 
> FULL_CONTEXT and we assume that the packet does not invalidate the dynamic 
> chain, downgrading the state is not a good solution.
> 
> 3. If the decompressor is in NO_CONTEXT state, the new state is set to 
> STATIC_CONTEXT. Otherwise, the state is left unchanged.  
> 

I would say that alternative 3 is what we meant with the text you quote. Since 
the impl. guide has not yet been updated with this (partially due to lack of 
anyone commenting on it), we should make some text that makes this point clear 
as soon as we update it.

Rgds,
	Kristofer Sandlund, Effnet AB

> Regards
> 
> Pawel
> 
> ----------------------------------------------------
> Fani zespo³u Metallica ³±czcie siê! Do³±czamy do majowego koncertu!
> http://klik.wp.pl/?adr=http%3A%2F%2Fmuzyka.wp.pl%2Fimprezy.html%3Fidn%3D829&sid=157
> 

_______________________________________________
Rohc mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rohc

---

From: "Pawel Szymanski" <[email-masked]>
Date: Tue, 6 Apr 2004 16:43:31 +0200

Hi Kristofer,

Regards

Pawel

----------------------------------------------------
Fani zespołu Metallica łączcie się! Dołączamy do majowego koncertu!
http://klik.wp.pl/?adr=http%3A%2F%2Fmuzyka.wp.pl%2Fimprezy.html%3Fidn%3D829&sid=157

---

From: "Pawel Szymanski" <[email-masked]>
Date: Wed, 7 Apr 2004 11:29:18 +0200

Hi Kristofer,

See my comments below
 
> 	Kristofer Sandlund, Effnet AB

But isn't the option 3 against the RFC 3095, as the decompressor state 
transition diagram (section 5.3.2, page 57] does not show transition from 
NO_CONTEXT to STATIC_CONTEXT ?

Regards

Pawel

----------------------------------------------------
Przegląd Piosenki Aktorskiej "Artyści Europy". 
Wrocław 23.04 - 2.05.2004 r. Gwiazdy, spektakle, recitale, koncerty
specjalne! http://klik.wp.pl/?adr=http%3A%2F%2Fwww.ppa.art.pl%2Fsub-ppa.php%3Fpid%3D65&sid=158